## hubzero-mw2-exec-service 2.2.4

=== Makefile ===
# @package      hubzero-mw2-exec-service
# @file         Makefile
# @author       Pascal Meunier <pmeunier@purdue.edu>
# @copyright    Copyright (c) 2016-2017 HUBzero Foundation, LLC.
# @license      http://opensource.org/licenses/MIT MIT
#
#
# Copyright (c) 2016-2017 HUBzero Foundation, LLC.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of HUBzero Foundation, LLC.
#

# Common libraries are installed as owned by root so the client can't modify them, as root may need to use them

VARLIBDIR=$(DESTDIR)/var/lib
LOGDIR=$(DESTDIR)/var/log
OWNER=root
USRBIN=$(DESTDIR)/usr/bin
USRSBIN=$(DESTDIR)/usr/sbin
USRLIB=$(DESTDIR)/usr/lib
ETC=$(DESTDIR)/etc
USRSHARE=$(DESTDIR)/usr/share
USRSHAREMAN=$(DESTDIR)/usr/share/man
USRSHAREDOC=$(DESTDIR)/usr/share/doc
SBIN=$(DESTDIR)/sbin
VARLOG=$(DESTDIR)/var/log
USRSHAREMANMAN8=$(DESTDIR)/usr/share/man/man8
USRLOCAL=$(DESTDIR)/usr/local
VZDIR=$(DESTDIR)/vz

all:
	@true

install:
	install --mode 0755 -D maxwell_service $(USRBIN)/maxwell_service
	install --mode 0755 -D firewall_readd $(USRBIN)/firewall_readd
	install --mode 0755 -D mkvztemplate $(USRBIN)/mkvztemplate
	install --mode 0755 -D make_xvnc_cert.sh $(USRBIN)/make_xvnc_cert.sh
	install --mode 0644 -D logrotate_mw2-exec-service $(ETC)/logrotate.d/logrotate_mw2-exec-service
	install --mode 0640 -D mw-exec-service.conf $(ETC)/mw-service/exec.conf
	install --mode 0600 -D hub-session.conf $(ETC)/vz/conf/hub-session.conf
	# mount and umount scripts must be executable by root (0700)
	install --mode 0700 -D hub-session.mount $(ETC)/vz/conf/hub-session.mount
	install --mode 0700 -D hub-session.umount $(ETC)/vz/conf/hub-session.umount
	install --mode 0750 -d $(VARLOG)/mw-service
	install --mode 0750 -d $(VARLOG)/mw-service/open-sessions
	install --mode 0750 -d $(DESTDIR)/vz/lock

manual_install:  install
	if [ ! -d $(VZDIR)/template/debian-7.0-amd64-maxwell ]; then \
	  $(USRBIN)/mkvztemplate amd64 wheezy ellie; \
	fi
	if [ -e $(ETCDIR)/mw-service/notify.key ]; then chmod 0600 $(ETCDIR)/mw-service/notify.key; fi

uninstall:
	rm -f $(USRBIN)/maxwell_service
	rm -f $(USRBIN)/firewall_readd
	rm -f $(ETC)/logrotate.d/logrotate_mw2-exec-service

postinst:
	chown root:adm /var/log/mw-service
	chown root:adm /var/log/mw-service/open-sessions
	if [ -f /etc/mw-client/notify.key -a ! -f /etc/mw-service/notify.key ]; then \
	  cp /etc/mw-client/notify.key /etc/mw-service/notify.key \
	fi
	if [ -f /etc/mw-service/notify.key ]; then \
	  chown root:root /etc/mw-service/notify.key \
	  chmod 0600 /etc/mw-service/notify.key \
	fi

clean:
	rm -f $(USRBIN)/maxwell_service
	rm -f $(USRBIN)/firewall_readd
	rm -f $(ETC)/logrotate.d/logrotate_mw2-exec-service

.PHONY: all install uninstall postinst clean

## hubzero-mw2-exec-service 2.2.9

=== Makefile ===
--- 
+++ 
@@ -30,8 +30,6 @@
 
 # Common libraries are installed as owned by root so the client can't modify them, as root may need to use them
 
-VARLIBDIR=$(DESTDIR)/var/lib
-LOGDIR=$(DESTDIR)/var/log
 OWNER=root
 USRBIN=$(DESTDIR)/usr/bin
 USRSBIN=$(DESTDIR)/usr/sbin
@@ -44,7 +42,16 @@
 VARLOG=$(DESTDIR)/var/log
 USRSHAREMANMAN8=$(DESTDIR)/usr/share/man/man8
 USRLOCAL=$(DESTDIR)/usr/local
-VZDIR=$(DESTDIR)/vz
+
+# @TODO Don't rely on link between /var/lib/vz and /vz
+DISTRIBUTION:=$(shell lsb_release -i -s)
+ifeq ($(DISTRIBUTION),Debian)
+VZ=$(DESTDIR)/var/lib/vz
+VZLINK="/var/lib/vz $(DESTDIR)/vz"
+else
+VZ=$(DESTDIR)/vz
+VZLINK="/vz $(DESTDIR)/var/lib/vz"
+endif
 
 all:
 	@true
@@ -62,13 +69,14 @@
 	install --mode 0700 -D hub-session.umount $(ETC)/vz/conf/hub-session.umount
 	install --mode 0750 -d $(VARLOG)/mw-service
 	install --mode 0750 -d $(VARLOG)/mw-service/open-sessions
-	install --mode 0750 -d $(DESTDIR)/vz/lock
+	install --mode 0750 -d $(VZ)/lock
+	ln -s $(VZLINK)
 
 manual_install:  install
-	if [ ! -d $(VZDIR)/template/debian-7.0-amd64-maxwell ]; then \
+	if [ ! -d $(VZ)/template/debian-7.0-amd64-maxwell ]; then \
 	  $(USRBIN)/mkvztemplate amd64 wheezy ellie; \
 	fi
-	if [ -e $(ETCDIR)/mw-service/notify.key ]; then chmod 0600 $(ETCDIR)/mw-service/notify.key; fi
+	if [ -e $(ETC)/mw-service/notify.key ]; then chmod 0600 $(ETC)/mw-service/notify.key; fi
 
 uninstall:
 	rm -f $(USRBIN)/maxwell_service

## hubzero-mw2-exec-service 2.2.10

=== Makefile ===
--- 
+++ 
@@ -47,10 +47,10 @@
 DISTRIBUTION:=$(shell lsb_release -i -s)
 ifeq ($(DISTRIBUTION),Debian)
 VZ=$(DESTDIR)/var/lib/vz
-VZLINK="/var/lib/vz $(DESTDIR)/vz"
+VZLINK=/var/lib/vz $(DESTDIR)/vz
 else
 VZ=$(DESTDIR)/vz
-VZLINK="/vz $(DESTDIR)/var/lib/vz"
+VZLINK=/vz $(DESTDIR)/var/lib/vz
 endif
 
 all:

## hubzero-mw2-exec-service 2.2.13-1+deb8

=== debian/changelog ===
hubzero-mw2-exec-service (2.2.13-1+deb8) unstable; urgency=low

  * remove umount lock before exiting with an error.  Perform cleanup
    in private area instead of from root/VEID area so it doesn't 
    depend on simfs mount being rw, because sometimes OpenVZ makes it ro.
  * rotate any .log file in mw-service directory; testing: prevent 
    recording false success on 'check' test
  * Added additional support packages required to run hapi scripts, 
    install Jupyter, etc.

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 18 Apr 2019 11:23:00 -0400

hubzero-mw2-exec-service (2.2.12-1) unstable; urgency=low

  * fix permissions on /var/lib when installing from Makefile
  * adapt session termination to use firewall_cleanup
  * add iohelper support for Docker
  * fix trying to get user group membership

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Tue, 19 Feb 2019 15:02:13 -0500

hubzero-mw2-exec-service (2.2.11-1) unstable; urgency=low

  * rpm package cleanup
  * configuration file renamed

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Tue, 18 Dec 2018 17:06:30 -0500

hubzero-mw2-exec-service (2.2.10-1) unstable; urgency=low

  * VZLINK definition shouldn't use quotes (fixes /vz symlink creation)

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Tue, 26 Jun 2018 16:22:57 -0400

hubzero-mw2-exec-service (2.2.9-1) unstable; urgency=low

  * add hubzero-mw2-dispatch to dependency list

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Tue, 26 Jun 2018 15:42:54 -0400

hubzero-mw2-exec-service (2.2.8-1) unstable; urgency=low

  * update debian package dependencies

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Tue, 26 Jun 2018 11:34:45 -0400

hubzero-mw2-exec-service (2.2.7-1) unstable; urgency=low

  * mark debian packaging to conflict with hubzero-mw-service

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Mon, 25 Jun 2018 13:50:16 -0400

hubzero-mw2-exec-service (2.2.6-1) unstable; urgency=low

  * create link between /vz and /var/lib/vz (depending on distro)

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Mon, 18 Jun 2018 15:13:32 -0400

hubzero-mw2-exec-service (2.2.5-1) unstable; urgency=low

  * mkvztemplate: create /dev/pts mountpoint if missing [stretch chroot]

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Fri, 08 Jun 2018 16:42:23 -0400

hubzero-mw2-exec-service (2.2.4-1) unstable; urgency=low

  * mkvztemplate: -e option to echo is shell/version dependent

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 07 Jun 2018 16:45:02 -0400

hubzero-mw2-exec-service (2.2.3-1) unstable; urgency=low

  * debian 8 packaging support
  * updated mkvztemplate to support debian 8 and 9 targets
  * do not mount /home in .mount script, only the home directory of the user will be mounted

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 07 Jun 2018 15:49:29 -0400

hubzero-mw2-exec-service (2.2.2-1) unstable; urgency=low

  * explicitly set directory permissions in case of restrictive umask

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 19 Apr 2018 15:20:05 -0400

hubzero-mw2-exec-service (2.2.1-1) unstable; urgency=low

  * sync mkvztemplate with hubzero-mw-service (primarily RHEL6 support)

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 19 Apr 2018 13:41:56 -0400

hubzero-mw2-exec-service (2.2.0-1) unstable; urgency=low

  * Initial release of packaged hubzero-mw2-exec-service

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Fri, 13 Apr 2018 14:19:21 -0400

## hubzero-mw2-exec-service 2.2.15-1+deb8

=== Makefile ===
--- 
+++ 
@@ -40,17 +40,22 @@
 USRSHAREDOC=$(DESTDIR)/usr/share/doc
 SBIN=$(DESTDIR)/sbin
 VARLOG=$(DESTDIR)/var/log
+VARLIB=$(DESTDIR)/var/lib
 USRSHAREMANMAN8=$(DESTDIR)/usr/share/man/man8
 USRLOCAL=$(DESTDIR)/usr/local
+ROOT=$(DESTDIR)/
 
 # @TODO Don't rely on link between /var/lib/vz and /vz
 DISTRIBUTION:=$(shell lsb_release -i -s)
+MAJOR_VERSION:=$(shell lsb_release -r -s | cut -d . -f 1)
+
+# Debian OpenVZ directory is /var/lib/vz,  we create /vz -> /var/lib/vz [ ln -s /var/lib/vz /vz ]
+# Redhat OpenVZ directory is /vz, we create /var/lib/vz -> /vz [ ln -s /vz /var/lib/vz ]
+
 ifeq ($(DISTRIBUTION),Debian)
 VZ=$(DESTDIR)/var/lib/vz
-VZLINK=/var/lib/vz $(DESTDIR)/vz
 else
 VZ=$(DESTDIR)/vz
-VZLINK=/vz $(DESTDIR)/var/lib/vz
 endif
 
 all:
@@ -62,21 +67,57 @@
 	install --mode 0755 -D mkvztemplate $(USRBIN)/mkvztemplate
 	install --mode 0755 -D make_xvnc_cert.sh $(USRBIN)/make_xvnc_cert.sh
 	install --mode 0644 -D logrotate_mw2-exec-service $(ETC)/logrotate.d/logrotate_mw2-exec-service
-	install --mode 0640 -D mw-exec-service.conf $(ETC)/mw-service/exec.conf
+	install --mode 0640 -D mw-exec-service.conf $(ETC)/mw-service/mw-exec-service.conf
 	install --mode 0600 -D hub-session.conf $(ETC)/vz/conf/hub-session.conf
 	# mount and umount scripts must be executable by root (0700)
 	install --mode 0700 -D hub-session.mount $(ETC)/vz/conf/hub-session.mount
 	install --mode 0700 -D hub-session.umount $(ETC)/vz/conf/hub-session.umount
 	install --mode 0750 -d $(VARLOG)/mw-service
 	install --mode 0750 -d $(VARLOG)/mw-service/open-sessions
-	install --mode 0750 -d $(VZ)/lock
-	ln -s $(VZLINK)
+
+	if [ -f /etc/debian_version ]; then install --mode 0750 -d $(VARLIB)/vz/lock ; fi
+	if [ -f /etc/debian_version -a ! -e $(ROOT)/vz ]; then ln -s /var/lib/vz $(ROOT)/vz ; fi
+
+	# /var/lib must be 0755
+	if [ -f /etc/redhat-release ]; then install --mode 0755 -d $(VARLIB); fi
+	if [ -f /etc/redhat-release ]; then install --mode 0750 -d $(ROOT)/vz/lock ; fi
+	if [ -f /etc/redhat-release -a ! -e $(VARLIB)/vz ]; then ln -s /vz $(VARLIB)/vz ; fi
 
 manual_install:  install
+  # create OpenVZ container template
 	if [ ! -d $(VZ)/template/debian-7.0-amd64-maxwell ]; then \
 	  $(USRBIN)/mkvztemplate amd64 wheezy ellie; \
 	fi
 	if [ -e $(ETC)/mw-service/notify.key ]; then chmod 0600 $(ETC)/mw-service/notify.key; fi
+  # self-signed XVNC certificate used by stunnel 
+	/usr/bin/make_xvnc_cert.sh
+
+docker_install: install
+  # like manual_install but for Docker instead of OpenVZ
+  # self-signed XVNC certificate used by stunnel 
+	/usr/bin/make_xvnc_cert.sh
+	# Docker support
+	# /etc/mw-service/docker/
+	#                       -hubzero_services
+	#                       -hubzero_tools
+	#                       -hubzero_vncpasswd
+	install --mode 0644 -D Dockerfile.hubzero_services $(ETC)/mw-service/docker/hubzero_services/Dockerfile.hubzero_services
+	install --mode 0644 -D hubzero_jessie.list $(ETC)/mw-service/docker/hubzero_services/hubzero_jessie.list
+	# hzvncresize provided by hubzero-mw-session package
+	# install --mode 0644 -D hzvncresize $(ETC)/mw-service/docker/hubzero_services/hubzero_jessie.list
+	install --mode 0644 -D hubzero_package_key $(ETC)/mw-service/docker/hubzero_services/hubzero_package_key
+	install --mode 0644 -D startxvnc.docker $(ETC)/mw-service/docker/hubzero_services/startxvnc.docker
+	install --mode 0644 -D Dockerfile.hubzero_tools $(ETC)/mw-service/docker/hubzero_tools/Dockerfile.hubzero_tools
+	install --mode 0644 -D setup_accounts $(ETC)/mw-service/docker/hubzero_tools/setup_accounts
+	install --mode 0644 -D Dockerfile.hubzero_vncpasswd $(ETC)/mw-service/docker/hubzero_vncpasswd/Dockerfile.hubzero_vncpasswd
+	# /etc/docker default Docker network
+	install --mode 0644 -D daemon.json $(ETC)/docker/daemon.json
+	# middleware config with options to use Docker
+	install --mode 0640 -D mw-exec-service_docker.conf $(ETC)/mw-service/mw-exec-service.conf
+	# build the images
+	cd /etc/mw-service/docker/hubzero_vncpasswd; docker build -f Dockerfile.hubzero_vncpasswd --tag hubzero_vncpasswd .
+	cd /etc/mw-service/docker/hubzero_services; docker build -f Dockerfile.hubzero_services --tag hubzero_services .
+	cd /etc/mw-service/docker/hubzero_tools; docker build -f Dockerfile.hubzero_tools --tag hubzero_tools .
 
 uninstall:
 	rm -f $(USRBIN)/maxwell_service
@@ -98,5 +139,6 @@
 	rm -f $(USRBIN)/maxwell_service
 	rm -f $(USRBIN)/firewall_readd
 	rm -f $(ETC)/logrotate.d/logrotate_mw2-exec-service
+	rm -f /var/lib/vz/vz
 
 .PHONY: all install uninstall postinst clean

=== tests/Makefile ===

# MAKEFLAGS += --silent

TESTUSERID=182
TESTGROUPID=100
TESTUSERNAME=pmeunier
TEST_DB_CNF=~/.my.cnf
SESSNUM=1234
LOGPATH=/var/log/mw-service/service.log
EXT_PREFIX=/srv

ALLTESTS=check startvnc status resize startxapp screenshot stopvnc purgeoutputs notify_pretest_setup notify_command_finished notifyrestarted

.PHONY: prereq_aws cleanlog clean notify_pretest_setup

all: $(ALLTESTS)

clean: cleanlog clean_out
	rm -f $(ALLTESTS)

cleanlog:
	sudo rm -f $(LOGPATH)

prereq_aws:
	sudo grep EXT_PREFIX /etc/mw-service/exec.conf > /dev/null

check:
	sudo /usr/bin/maxwell_service check > check.out
	diff check.expected check.out
	touch check

startvnc:
	echo 'asdfadsfadfadf' | sudo /usr/bin/maxwell_service startvnc 1 780x680 24 > startvnc
	sudo grep done $(LOGPATH) || ( rm startvnc; exit 1 )

status: startvnc
	sudo /usr/bin/maxwell_service status 1 > status 2>status.err
	grep running status

# output is sent to log file when we try to redirect...
resize:
	sudo /usr/bin/maxwell_service resize 1 800x600 > resize
	sudo grep 'changed to 800x600' $(LOGPATH)

startxapp:
	sudo rm -f /var/log/mw-service/open-sessions/$(SESSNUM).err
	# /home/sessions: if LOCAL_SESSIONDIR,  copy session directories to local storage
	sudo rm -rf /home/sessions/pmeunier/$(SESSNUM)
	sudo /usr/bin/maxwell_fs erase_sessdir $(TESTUSERNAME) $(SESSNUM)
	sudo /usr/bin/maxwell_fs setup_dir $(TESTUSERNAME) $(SESSNUM)
	# start session 1234 for user apps, in container #1, to run workspace
	sudo /usr/bin/maxwell_service startxapp $(TESTUSERNAME) 1234 0 1 notify /apps/workspace/current/middleware/invoke -T r7 > startxapp
	# startxapp returns immediately with success while the tool starts in the background, need to check log files.
	# stdout redirect into startxapp file is always empty but is necessary so maxwell_service writes to log files.
	# wait for session log file.err to be created (REVISIT: use inotify instead of sleep?)
	sleep 10
	! ( sudo grep kill $(LOGPATH) || (rm -f startxapp && exit 1) )
	! ( sudo grep Error $(LOGPATH) || (rm -f startxapp && exit 1) )

screenshot: startxapp
	sudo /usr/bin/maxwell_service screenshot $(TESTUSERNAME) $(SESSNUM) 1 > screenshot

mount_paths: startxapp
	mkdir /tmp/testdir
	sudo /usr/bin/maxwell_service mount_paths /tmp/testdir
	rmdir /tmp/testdir

stopvnc: cleanlog startvnc
	sudo /usr/bin/maxwell_service stopvnc 1 > stopvnc
	rm startvnc*

killall:
	# this test requires a user to exist both in the account service and in the OS
	# 
	getent passwd $(TESTUSERNAME) > /dev/null || sudo useradd $(TESTUSERNAME)
	sudo su $(TESTUSERNAME) -c "sleep 50" &
	sudo /usr/bin/maxwell_service killall $(TESTUSERNAME)
	! ( pgrep -u $(TESTUSERNAME) > /dev/null )

killtree:

purgeoutputs:
	sudo touch /var/log/mw-service/open-sessions/$(SESSNUM).err
	sudo touch /var/log/mw-service/open-sessions/$(SESSNUM).out
	sudo /usr/bin/maxwell_service purgeoutputs $(SESSNUM)
	! [ -e /var/log/mw-service/open-sessions/$(SESSNUM).err ]
	! [ -e /var/log/mw-service/open-sessions/$(SESSNUM).out ]

notify_pretest_setup:
	# Notify tests assume that this is an all-in-one hub, with execution host being also the web server
	sudo grep MW_USER /etc/mw-service/*.conf  > /dev/null || ( echo 'For these tests, value for MW_USER must be specified in /etc/mw-service/exec.conf, try www-data or apache depending on OS' && exit 1 )
	# insert into database...  Assumes user that runs test has a .my.cnf file to connect to the test database.
	ls $(TEST_DB_CNF) > /dev/null
	mysql --defaults-file=$(TEST_DB_CNF) -e "delete from sessionlog"
	mysql --defaults-file=$(TEST_DB_CNF) -e "insert into sessionlog (exechost, sessnum) values ('127.0.0.1', $(SESSNUM))"
	sudo rm -rf /var/log/mw-service/open-sessions/
	sudo mkdir -p /var/log/mw-service/open-sessions/
	sudo touch /var/log/mw-service/open-sessions/$(SESSNUM).err
	sudo touch /var/log/mw-service/open-sessions/$(SESSNUM).out

notify_command_finished: notify_pretest_setup
	# notify about session 1234 explicitly and only
	sudo /usr/bin/maxwell_service notify_command_finished $(SESSNUM) localhost
	# client should have fetched these and deleted them
	! [ -e /var/log/mw-service/open-sessions/$(SESSNUM).err ]
	! [ -e /var/log/mw-service/open-sessions/$(SESSNUM).out ]

notifyrestarted: notify_pretest_setup
	# notify about sessions based on the existence of .err files
	sudo /usr/bin/maxwell_service notifyrestarted
	# client should have fetched these and deleted them
	! [ -e /var/log/mw-service/open-sessions/$(SESSNUM).err ]
	! [ -e /var/log/mw-service/open-sessions/$(SESSNUM).out ]

# anonymous sessions support functions, experimental, not tested
anonymous:
update_resources: 

clean_out:
	rm -f *.out

=== debian/changelog ===
hubzero-mw2-exec-service (2.2.15-1+deb8) unstable; urgency=low

  * mkzvtemplate: get wheezy packages for debian archive now

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Tue, 23 Apr 2019 11:07:05 -0400

hubzero-mw2-exec-service (2.2.13-1) unstable; urgency=low

  * remove umount lock before exiting with an error.  Perform cleanup
    in private area instead of from root/VEID area so it doesn't 
    depend on simfs mount being rw, because sometimes OpenVZ makes it ro.
  * rotate any .log file in mw-service directory; testing: prevent 
    recording false success on 'check' test
  * Added additional support packages required to run hapi scripts, 
    install Jupyter, etc.

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 18 Apr 2019 11:23:00 -0400

=== debian/rules ===
#!/usr/bin/make -f
#
# @package      hubzero-mw2-exec-service
# @file         rules
# @author       Nicholas J. Kisseberth <nkissebe@purdue.edu>
# @copyright    Copyright (c) 2010-2018 HUBzero Foundation, LLC.
# @license      http://opensource.org/licenses/MIT MIT
#
# Copyright (c) 2010-2018 HUBzero Foundation, LLC.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of HUBzero Foundation, LLC.
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

$(info ########## Goals: $(MAKECMDGOALS) ##########)

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export CFLAGS
export CPPFLAGS
export CXXFLAGS
export LDFLAGS

DEB_MAJOR:=$(shell lsb_release -r -s | cut -d . -f 1)

configure:
	@echo "########## configure ##########"
	dh_testdir
	>$@

build: configure
	@echo "########## build ##########"
	dh_testdir
	$(MAKE)
	>$@

clean:
	@echo "########## clean ##########"
	dh_testdir
	dh_testroot
	rm -fr build configure
	$(MAKE) clean
	dh_clean

install: build
	@echo "########## install ##########"
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	#$(MAKE) DESTDIR=$(CURDIR)/debian/hubzero-mw2-exec-service install
	$(MAKE) DESTDIR=$(CURDIR)/debian/hubzero-mw2-exec-service COMPILE=--no-compile install

binary-indep: install
	@echo "########## binary-indep ##########"
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
	dh_install -i
	dh_installlogrotate -i
	dh_installinit -i
	dh_installman -i
	#dh_python2 -i
	dh_link -i
	dh_strip -i
	dh_lintian -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install
	@echo "########## binary-arch ##########"
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a
	dh_installlogrotate -a
	dh_installinit -a
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_lintian -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep 
#binary: binary-arch
	@echo "########## binary ##########"

.PHONY: clean binary-indep binary-arch binary install

## hubzero-mw2-exec-service 2.2.18-1+deb9

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,10 @@
 # @package      hubzero-mw2-exec-service
 # @file         Makefile
-# @author       Pascal Meunier <pmeunier@purdue.edu>
-# @copyright    Copyright (c) 2016-2017 HUBzero Foundation, LLC.
+# @copyright    Copyright (c) 2016-2020 The Regents of the University of California.
 # @license      http://opensource.org/licenses/MIT MIT
 #
 #
-# Copyright (c) 2016-2017 HUBzero Foundation, LLC.
+# Copyright (c) 2016-2020 The Regents of the University of California.
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # of this software and associated documentation files (the "Software"), to deal
@@ -25,7 +24,7 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 # THE SOFTWARE.
 #
-# HUBzero is a registered trademark of HUBzero Foundation, LLC.
+# HUBzero is a registered trademark of The Regents of the University of California.
 #
 
 # Common libraries are installed as owned by root so the client can't modify them, as root may need to use them
@@ -84,8 +83,8 @@
 	if [ -f /etc/redhat-release -a ! -e $(VARLIB)/vz ]; then ln -s /vz $(VARLIB)/vz ; fi
 
 manual_install:  install
-  # create OpenVZ container template
-	if [ ! -d $(VZ)/template/debian-7.0-amd64-maxwell ]; then \
+  # create OpenVZ container template, if OpenVZ is installed
+	if [ -d $(VZ) ] && [ ! -d $(VZ)/template/debian-7.0-amd64-maxwell ]; then \
 	  $(USRBIN)/mkvztemplate amd64 wheezy ellie; \
 	fi
 	if [ -e $(ETC)/mw-service/notify.key ]; then chmod 0600 $(ETC)/mw-service/notify.key; fi
@@ -117,12 +116,17 @@
 	# build the images
 	cd /etc/mw-service/docker/hubzero_vncpasswd; docker build -f Dockerfile.hubzero_vncpasswd --tag hubzero_vncpasswd .
 	cd /etc/mw-service/docker/hubzero_services; docker build -f Dockerfile.hubzero_services --tag hubzero_services .
-	cd /etc/mw-service/docker/hubzero_tools; docker build -f Dockerfile.hubzero_tools --tag hubzero_tools .
+	# FIXME: building hubzero_tools fails if hubzero-debian-7.0-amd64 image doesn't exist
+	# build hubzero_tools only if the hubzero-debian-7.0-amd64 image exists?
+	# or install different version of Dockerfile.hubzero_tools that builds it all in one go?
+	# 
+	# cd /etc/mw-service/docker/hubzero_tools; docker build -f Dockerfile.hubzero_tools --tag hubzero_tools .
 
 uninstall:
 	rm -f $(USRBIN)/maxwell_service
 	rm -f $(USRBIN)/firewall_readd
 	rm -f $(ETC)/logrotate.d/logrotate_mw2-exec-service
+	rm -f /var/lib/vz/vz
 
 postinst:
 	chown root:adm /var/log/mw-service
@@ -136,9 +140,6 @@
 	fi
 
 clean:
-	rm -f $(USRBIN)/maxwell_service
-	rm -f $(USRBIN)/firewall_readd
-	rm -f $(ETC)/logrotate.d/logrotate_mw2-exec-service
-	rm -f /var/lib/vz/vz
+	@true
 
 .PHONY: all install uninstall postinst clean

=== tests/Makefile ===
--- 
+++ 
@@ -30,8 +30,8 @@
 	touch check
 
 startvnc:
-	echo 'asdfadsfadfadf' | sudo /usr/bin/maxwell_service startvnc 1 780x680 24 > startvnc
-	sudo grep done $(LOGPATH) || ( rm startvnc; exit 1 )
+	echo 'asdfadsfadfadf' | sudo /usr/bin/maxwell_service startvnc 1 780x680 24 > startvnc.out
+	sudo grep done $(LOGPATH) && touch startvnc
 
 status: startvnc
 	sudo /usr/bin/maxwell_service status 1 > status 2>status.err
@@ -42,6 +42,7 @@
 	sudo /usr/bin/maxwell_service resize 1 800x600 > resize
 	sudo grep 'changed to 800x600' $(LOGPATH)
 
+# this test requires the hubzero-mw2-file-service package on the same host...
 startxapp:
 	sudo rm -f /var/log/mw-service/open-sessions/$(SESSNUM).err
 	# /home/sessions: if LOCAL_SESSIONDIR,  copy session directories to local storage
@@ -49,20 +50,21 @@
 	sudo /usr/bin/maxwell_fs erase_sessdir $(TESTUSERNAME) $(SESSNUM)
 	sudo /usr/bin/maxwell_fs setup_dir $(TESTUSERNAME) $(SESSNUM)
 	# start session 1234 for user apps, in container #1, to run workspace
-	sudo /usr/bin/maxwell_service startxapp $(TESTUSERNAME) 1234 0 1 notify /apps/workspace/current/middleware/invoke -T r7 > startxapp
+	sudo /usr/bin/maxwell_service startxapp $(TESTUSERNAME) 1234 0 1 notify /apps/workspace/current/middleware/invoke -T r7 > startxapp.out
 	# startxapp returns immediately with success while the tool starts in the background, need to check log files.
 	# stdout redirect into startxapp file is always empty but is necessary so maxwell_service writes to log files.
 	# wait for session log file.err to be created (REVISIT: use inotify instead of sleep?)
 	sleep 10
-	! ( sudo grep kill $(LOGPATH) || (rm -f startxapp && exit 1) )
-	! ( sudo grep Error $(LOGPATH) || (rm -f startxapp && exit 1) )
+	! ( grep kill startxapp.out)
+	! ( grep Error startxapp.out)
+	touch startxapp
 
 screenshot: startxapp
 	sudo /usr/bin/maxwell_service screenshot $(TESTUSERNAME) $(SESSNUM) 1 > screenshot
 
 mount_paths: startxapp
 	mkdir /tmp/testdir
-	sudo /usr/bin/maxwell_service mount_paths /tmp/testdir
+	sudo /usr/bin/maxwell_service mount_paths 1 /tmp/testdir
 	rmdir /tmp/testdir
 
 stopvnc: cleanlog startvnc

=== debian/changelog ===
hubzero-mw2-exec-service (2.2.18-1+deb9) unstable; urgency=low

  * catch and log exceptions that happen during tool start
  * add Debian 9 support
 
 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 19 Aug 2020 18:37:49 -0700

hubzero-mw2-exec-service (2.2.17-1) unstable; urgency=low

  * update destination rpm upload directory
  * update copyright years
  * remove per file @author references
  * update email address references
  * update copyright/trademark ownership
  * disable core dumps and set results_directory better
  * changed docker ps filter to use container names instead of ancestor
    because ancestor was missing old containers
  * bug fix for helper resource file
  * commented out build step for hubzero_tools until a better thought-out
    solution is available
  * support for ionhelper and generic helper trusted accounts
  * added MW_USER setting to example configuration
  * set configuration defaults for Docker instead of onescienceplace;
    more comments

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Sun, 03 May 2020 18:53:38 -0700

hubzero-mw2-exec-service (2.2.16-1) unstable; urgency=low

  * in manual installation, don't try to create OpenVZ tool template if /vz
    doesn't exist, that probably means OpenVZ isn
  * catch exception when invoking tool to be able to send notification
  * Docker tool container will sleep only 5 seconds at a time to respond to some events
  * untested changes: support for foreign mounts with Docker
  * firewall_readd made Docker-compatible
  * persist and retry longer to stop containers and cleanup, to decrease number of broken containers

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 09 Oct 2019 14:56:22 -0400

hubzero-mw2-exec-service (2.2.15-1) unstable; urgency=low

  * mkzvtemplate: get wheezy packages for debian archive now

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Tue, 23 Apr 2019 11:07:05 -0400

=== debian/control ===
Source: hubzero-mw2-exec-service
Section: misc
Priority: optional
Maintainer: Pascal Meunier <pmeunier@purdue.edu>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.8.4
X-Python-Version: >= 2.7
Homepage: http://hubzero.org

Package: hubzero-mw2-exec-service
Architecture: all
Depends: python (>=2.7), hubzero-mw2-common, hubzero-mw2-dispatch, time, openssh-client, openssh-server, quota, debootstrap, vzctl, socat, stunnel4, ${misc:Depends}, ${misc:Depends}
Conflicts: hubzero-mw-service
Replaces: hubzero-mw-service
Description: HUBzero Middleware 2 Execution Service
 Execution service for HUBzero Middleware 2

=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,10 @@
 #
 # @package      hubzero-mw2-exec-service
 # @file         rules
-# @author       Nicholas J. Kisseberth <nkissebe@purdue.edu>
-# @copyright    Copyright (c) 2010-2018 HUBzero Foundation, LLC.
+# @copyright    Copyright (c) 2010-2020 The Regents of the University of California.
 # @license      http://opensource.org/licenses/MIT MIT
 #
-# Copyright (c) 2010-2018 HUBzero Foundation, LLC.
+# Copyright (c) 2010-2020 The Regents of the University of California.
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # of this software and associated documentation files (the "Software"), to deal
@@ -26,7 +25,7 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 # THE SOFTWARE.
 #
-# HUBzero is a registered trademark of HUBzero Foundation, LLC.
+# HUBzero is a registered trademark of The Regents of the University of California.
 #
 
 # Uncomment this to turn on verbose mode.

## hubzero-mw2-exec-service 2.2.25-1+deb7

=== Makefile ===
--- 
+++ 
@@ -60,11 +60,14 @@
 all:
 	@true
 
-install:
+install_code_only:
 	install --mode 0755 -D maxwell_service $(USRBIN)/maxwell_service
 	install --mode 0755 -D firewall_readd $(USRBIN)/firewall_readd
 	install --mode 0755 -D mkvztemplate $(USRBIN)/mkvztemplate
 	install --mode 0755 -D make_xvnc_cert.sh $(USRBIN)/make_xvnc_cert.sh
+# consider compiling maxwell_service (python2 -m compileall)
+
+install: install_code_only
 	install --mode 0644 -D logrotate_mw2-exec-service $(ETC)/logrotate.d/logrotate_mw2-exec-service
 	install --mode 0640 -D mw-exec-service.conf $(ETC)/mw-service/mw-exec-service.conf
 	install --mode 0600 -D hub-session.conf $(ETC)/vz/conf/hub-session.conf
@@ -82,19 +85,6 @@
 	if [ -f /etc/redhat-release ]; then install --mode 0750 -d $(ROOT)/vz/lock ; fi
 	if [ -f /etc/redhat-release -a ! -e $(VARLIB)/vz ]; then ln -s /vz $(VARLIB)/vz ; fi
 
-manual_install:  install
-  # create OpenVZ container template, if OpenVZ is installed
-	if [ -d $(VZ) ] && [ ! -d $(VZ)/template/debian-7.0-amd64-maxwell ]; then \
-	  $(USRBIN)/mkvztemplate amd64 wheezy ellie; \
-	fi
-	if [ -e $(ETC)/mw-service/notify.key ]; then chmod 0600 $(ETC)/mw-service/notify.key; fi
-  # self-signed XVNC certificate used by stunnel 
-	/usr/bin/make_xvnc_cert.sh
-
-docker_install: install
-  # like manual_install but for Docker instead of OpenVZ
-  # self-signed XVNC certificate used by stunnel 
-	/usr/bin/make_xvnc_cert.sh
 	# Docker support
 	# /etc/mw-service/docker/
 	#                       -hubzero_services
@@ -102,8 +92,7 @@
 	#                       -hubzero_vncpasswd
 	install --mode 0644 -D Dockerfile.hubzero_services $(ETC)/mw-service/docker/hubzero_services/Dockerfile.hubzero_services
 	install --mode 0644 -D hubzero_jessie.list $(ETC)/mw-service/docker/hubzero_services/hubzero_jessie.list
-	# hzvncresize provided by hubzero-mw-session package
-	# install --mode 0644 -D hzvncresize $(ETC)/mw-service/docker/hubzero_services/hubzero_jessie.list
+	# public key for HUBzero packages, so that containers can install software
 	install --mode 0644 -D hubzero_package_key $(ETC)/mw-service/docker/hubzero_services/hubzero_package_key
 	install --mode 0644 -D startxvnc.docker $(ETC)/mw-service/docker/hubzero_services/startxvnc.docker
 	install --mode 0644 -D Dockerfile.hubzero_tools $(ETC)/mw-service/docker/hubzero_tools/Dockerfile.hubzero_tools
@@ -111,6 +100,22 @@
 	install --mode 0644 -D Dockerfile.hubzero_vncpasswd $(ETC)/mw-service/docker/hubzero_vncpasswd/Dockerfile.hubzero_vncpasswd
 	# /etc/docker default Docker network
 	install --mode 0644 -D daemon.json $(ETC)/docker/daemon.json
+
+manual_install: install
+  # create OpenVZ container template, if OpenVZ is installed
+	if [ -d $(VZ) ] && [ ! -d $(VZ)/template/debian-7.0-amd64-maxwell ]; then \
+	  $(USRBIN)/mkvztemplate amd64 wheezy ellie; \
+	fi
+	if [ -e $(ETC)/mw-service/notify.key ]; then chmod 0600 $(ETC)/mw-service/notify.key; fi
+  # self-signed XVNC certificate used by stunnel
+	/usr/bin/make_xvnc_cert.sh
+
+refresh_code: install_code_only
+
+docker_install: install
+  # like manual_install but for Docker instead of OpenVZ
+  # self-signed XVNC certificate used by stunnel
+	/usr/bin/make_xvnc_cert.sh
 	# middleware config with options to use Docker
 	install --mode 0640 -D mw-exec-service_docker.conf $(ETC)/mw-service/mw-exec-service.conf
 	# build the images
@@ -119,7 +124,7 @@
 	# FIXME: building hubzero_tools fails if hubzero-debian-7.0-amd64 image doesn't exist
 	# build hubzero_tools only if the hubzero-debian-7.0-amd64 image exists?
 	# or install different version of Dockerfile.hubzero_tools that builds it all in one go?
-	# 
+	#
 	# cd /etc/mw-service/docker/hubzero_tools; docker build -f Dockerfile.hubzero_tools --tag hubzero_tools .
 
 uninstall:

=== debian/changelog ===
hubzero-mw2-exec-service (2.2.25-1+deb7) unstable; urgency=low

    update debian stretch repo in docker services dockerfile

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Mon, 17 Jul 2023 18:21:43 -0700

hubzero-mw2-exec-service (2.2.24-1) unstable; urgency=low

    tweak comments
    fix for race condition when ending tool sessions.  Requires matching fix in container.py
    created target install_code_only

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Tue, 14 Sep 2021 15:06:12 -0700

hubzero-mw2-exec-service (2.2.23-1) unstable; urgency=low

  *  set default (off) values for DOCKER_XSHM, DOCKER_GPUS, DOCKER_VGL features

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Mon, 25 Jan 2021 16:06:41 -0800

hubzero-mw2-exec-service (2.2.22-1) unstable; urgency=low

  * fix rpm packaging to include proper dockerfiles

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 09 Dec 2020 12:32:35 -0800

hubzero-mw2-exec-service (2.2.21-1) unstable; urgency=low

  * fix packaging to include proper dockerfiles

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 09 Dec 2020 12:16:35 -0800

hubzero-mw2-exec-service (2.2.20-1) unstable; urgency=low

  * don't create password for vnc service if one was volume mounted into container

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 02 Dec 2020 15:33:19 -0800

hubzero-mw2-exec-service (2.2.19-1) unstable; urgency=low

  * explicitly call python2 for CentOS 8 compatibility
  * New Dockerfile.hubzero_services with full font support and extra build capabilities

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Tue, 01 Dec 2020 14:35:29 -0800

hubzero-mw2-exec-service (2.2.18-1) unstable; urgency=low

  * catch and log exceptions that happen during tool start
  * add Debian 9 support
 
 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 19 Aug 2020 18:37:49 -0700

## hubzero-mw2-exec-service 2.2.25-1+deb10

=== debian/changelog ===
hubzero-mw2-exec-service (2.2.25-1+deb10) unstable; urgency=low

    update debian stretch repo in docker services dockerfile

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Mon, 17 Jul 2023 18:21:43 -0700
